#include "CuaSoChinh.h"
CuaSoChinh::CuaSoChinh() {
    // Tao cac widget cua cua so
    khoiTaoThaoTac();
    khoiTaoDanhMuc();
    khoiTaoThanhCongCu();
    khoiTaoThanhTrangThai();

    // Tao danh sach the va tai trang chu
    danhSachThe = new QTabWidget();
    danhSachThe->addTab(taoTheMoi(tr("http://laptrinhtanbinh.com")), tr("(Thẻ mới)"));
    connect(danhSachThe, SIGNAL(currentChanged(int)), this, SLOT(chuyenThe(int)));
    setCentralWidget(danhSachThe);

    // Tuy chinh cac chi tiet cua cua so
    setMinimumSize(1080, 768);
    setWindowIcon(QIcon("img/bando.png"));
    setWindowTitle(tr("Bản đồ X"));
}

void CuaSoChinh::khoiTaoThaoTac() {
    thaoTacThemThe = new QAction(tr("Thêm thẻ mới"), this);
    thaoTacThemThe->setShortcut(tr("Ctrl+T"));
    connect(thaoTacThemThe, SIGNAL(triggered()), this, SLOT(themThe()));
    thaoTacDongThe = new QAction(tr("Đóng thẻ"), this);
    thaoTacDongThe->setShortcut(tr("Ctrl+W"));
    connect(thaoTacDongThe, SIGNAL(triggered()), this, SLOT(dongThe()));
    thaoTacThoat = new QAction(tr("Thoát"), this);
    thaoTacThoat->setShortcut(tr("Ctrl+Q"));
    connect(thaoTacThoat, SIGNAL(triggered()), qApp, SLOT(quit()));

    thaotacTaiTrangTruoc = new QAction(QIcon("img/trangTruoc.png"), tr("Trang trước"), this);
    thaotacTaiTrangTruoc->setShortcut(QKeySequence::Back);
    connect(thaotacTaiTrangTruoc, SIGNAL(triggered()), this, SLOT(taiTrangTruoc()));
    thaoTactaiTrangSau = new QAction(QIcon("img/trangSau.png"), tr("Trang sau"), this);
    thaoTactaiTrangSau->setShortcut(QKeySequence::Forward);
    connect(thaoTactaiTrangSau, SIGNAL(triggered()), this, SLOT(taiTrangSau()));
    thaoTacDungTaiTrang = new QAction(QIcon("img/dung.png"), tr("Dừng"), this);
    connect(thaoTactaiTrangSau, SIGNAL(triggered()), this, SLOT(dungTai()));
    thaoTacLamMoiTrang = new QAction(QIcon("img/lamMoi.png"), tr("Tải lại"), this);
    thaoTacLamMoiTrang->setShortcut(QKeySequence::Refresh);
    connect(thaoTacLamMoiTrang, SIGNAL(triggered()), this, SLOT(taiLai()));
    thaoTacTaiTrangChu = new QAction(QIcon("img/trangChu.png"), tr("Trang chủ"), this);
    connect(thaoTacTaiTrangChu, SIGNAL(triggered()), this, SLOT(taiTrangChu()));
    thaoTacTaiTrang = new QAction(QIcon("img/go.png"), tr("Tải trang"), this);
    connect(thaoTacTaiTrang, SIGNAL(triggered()), this, SLOT(taiTrang()));

    thaoTacTroGiup = new QAction(tr("Trợ giúp"), this);
    connect(thaoTacTroGiup, SIGNAL(triggered()), this, SLOT(troGiup()));
    thaoTacTroGiup->setShortcut(QKeySequence::HelpContents);
}

void CuaSoChinh::khoiTaoDanhMuc() {
    QMenu *danhMucTep = menuBar()->addMenu(tr("&Tệp"));

    danhMucTep->addAction(thaoTacThemThe);
    danhMucTep->addAction(thaoTacDongThe);
    danhMucTep->addSeparator();
    danhMucTep->addAction(thaoTacThoat);

    QMenu *danhMucDuyet = menuBar()->addMenu(tr("Thao tác trình duyệt"));

    danhMucDuyet->addAction(thaotacTaiTrangTruoc);
    danhMucDuyet->addAction(thaoTactaiTrangSau);
    danhMucDuyet->addAction(thaoTacDungTaiTrang);
    danhMucDuyet->addAction(thaoTacLamMoiTrang);
    danhMucDuyet->addAction(thaoTacTaiTrangChu);


    QMenu *danhMucTroGiup = menuBar()->addMenu(tr("?"));

    danhMucTroGiup->addAction(thaoTacTroGiup);

}

void CuaSoChinh::khoiTaoThanhCongCu() {
    diaChi = new QLineEdit();
    connect(diaChi, SIGNAL(returnPressed()), this, SLOT(taiTrang()));

    QToolBar *thanhCongCuDuyet = addToolBar(tr("Công cụ duyệt"));

    thanhCongCuDuyet->addAction(thaotacTaiTrangTruoc);
    thanhCongCuDuyet->addAction(thaoTactaiTrangSau);
    thanhCongCuDuyet->addAction(thaoTacDungTaiTrang);
    thanhCongCuDuyet->addAction(thaoTacLamMoiTrang);
    thanhCongCuDuyet->addAction(thaoTacTaiTrangChu);
    thanhCongCuDuyet->addWidget(diaChi);
    thanhCongCuDuyet->addAction(thaoTacTaiTrang);
}

void CuaSoChinh::khoiTaoThanhTrangThai() {
    tienTrinh = new QProgressBar(this);
    tienTrinh->setVisible(false);
    tienTrinh->setMaximumHeight(14);
    statusBar()->addWidget(tienTrinh, 1);
}


QWidget* CuaSoChinh::taoTheMoi(QString url) {
    QWidget *trangThe = new QWidget();
    QWebView *khungTrangWeb = new QWebView();

    QVBoxLayout *lop = new QVBoxLayout();
    lop->setContentsMargins(0,0,0,0);
    lop->addWidget(khungTrangWeb);
    trangThe ->setLayout(lop);

    if (url.isEmpty())     {
        khungTrangWeb->load(QUrl(tr("html/trangTrang.html")));
    } else {
        if (url.left(7) != "http://") {
            url = "http://" + url;
        }
        khungTrangWeb->load(QUrl(url));
    }

    // Quan ly tin hieu gui boi trang the
    connect(khungTrangWeb, SIGNAL(titleChanged(QString)), this, SLOT(thayTieuDe(QString)));
    connect(khungTrangWeb, SIGNAL(urlChanged(QUrl)), this, SLOT(thayDiaChi(QUrl)));
    connect(khungTrangWeb, SIGNAL(loadStarted()), this, SLOT(batDauTienTrinh()));
    connect(khungTrangWeb, SIGNAL(loadProgress(int)), this, SLOT(taiTienTrinh(int)));
    connect(khungTrangWeb, SIGNAL(loadFinished(bool)), this, SLOT(ketThucTienTrinh(bool)));

    return trangThe;
}

QWebView *CuaSoChinh::trangHienTai() {
    return danhSachThe->currentWidget()->findChild<QWebView *>();
}

void CuaSoChinh::taiTrangTruoc() {
    trangHienTai()->back();
}

void CuaSoChinh::taiTrangSau() {
    trangHienTai()->forward();
}

void CuaSoChinh::taiTrangChu() {
    trangHienTai()->load(QUrl(tr("http://laptrinhtanbinh.com")));
}

void CuaSoChinh::dungTai() {
    trangHienTai()->stop();
}

void CuaSoChinh::taiLai() {
    trangHienTai()->reload();
}

void CuaSoChinh::troGiup() {
    QMessageBox::information(this, tr("Trợ giúp"), tr("BanDoX được thực hiện trong dự án minh họa của lớp học ngôn ngữ C++ của <a href=\"http://laptrinhtanbinh.com\">Lập trình Tân Binh</a>.<br />Mọi câu hỏi thắc mắc có thể được đưa ra trong phần thảo luận cuối bài học."));
}

void CuaSoChinh::themThe() {
    int chiSoTheMoi = danhSachThe->addTab(taoTheMoi(), tr("Thẻ mới"));
    danhSachThe->setCurrentIndex(chiSoTheMoi);
    diaChi->setText("");
    diaChi->setFocus(Qt::OtherFocusReason);
}

void CuaSoChinh::dongThe() {
    // Khong the dong neu chi co 1 the duy nhat
    if (danhSachThe->count() > 1)     {
        danhSachThe->removeTab(danhSachThe->currentIndex());
    } else {
        QMessageBox::critical(this, tr("Lỗi"), tr("Cần có it nhất 1 thẻ trong trình duyệt!"));
    }
}

void CuaSoChinh::taiTrang() {
    QString url = diaChi->text();
    // Them "http://" neu dia chi chua hoan chinh
    if (url.left(7) != "http://")     {
        url = "http://" + url;
        diaChi->setText(url);
    }
    trangHienTai()->load(QUrl(url));
}

void CuaSoChinh::chuyenThe(int chiSo) {
    thayTieuDe(trangHienTai()->title());
    thayDiaChi(trangHienTai()->url());
}

void CuaSoChinh::thayTieuDe(const QString & tieuDe) {
    QString tieuDeRutGon = tieuDe;
    // Cat bot tieu de de tranh tao re cac the qua rong
    if (tieuDe.size() > 40) {
        tieuDeRutGon = tieuDe.left(40) + "...";
    }
    setWindowTitle(tieuDeRutGon + " - " + tr("BanDoX"));
    danhSachThe->setTabText(danhSachThe ->currentIndex(),tieuDeRutGon);
}

void CuaSoChinh::thayDiaChi(const QUrl & url) {
    if (url.toString() != tr("html/trangTrang.html")) {
        diaChi->setText(url.toString());
    }
}

void CuaSoChinh::batDauTienTrinh() {
    tienTrinh->setVisible(true);
}

void CuaSoChinh::taiTienTrinh(int tienDo) {
    tienTrinh->setValue(tienDo);
}

void CuaSoChinh::ketThucTienTrinh(bool ok) {
    tienTrinh->setVisible(false);
    statusBar()->showMessage(tr("Hoàn tất"), 2000);
}




